
#Equivalent to JOGLTools Shape

import TriangleMeshGeometry
#import Appearance

class Shape:
	geometry = None
	appearance = None
	
	def __init__(self, geometry  = None, appearance = None):
		self.geometry = geometry
		self.appearance = appearance
		
		
	def setAppearance(self, appearance):
		self.appearance = appearance
	
	def getAppearance(self):
		return self.appearance
		
	def setGeometry(self, geometry):
		self.geometry = geometry
	def getGeometry(self):
		return self.geometry
		
	#This render path will create and use GL lists
	def Render(self):
		self.preRender()
		self.geometry.Render()
		self.postRender()
		
	#This render path will NOT create and use GL lists. 
	#Useful for putting into a list from higher in the heirarchy
	def RenderNoList(self):
		self.preRender()
		self.geometry.RenderNoList()
		self.postRender()
		
	def preRender(self):
		if (self.appearance != None):
			self.appearance.preRender()
	
	def postRender(self):
		if (self.appearance != None):
			self.appearance.postRender()